/* Copyright © 2016 Ganchrow Scientific, SA all rights reserved */
'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
class Chunker {
    constructor(split) {
        this.partial = '';
        this.split = split || Chunker.LINEFEED;
    }
    forEachCompleteChunk(dataBuf, cb) {
        let data = dataBuf.toString('utf8').split(this.split);
        let lastIdx = data.length - 1;
        this.partial += data[0];
        for (let i = 0; i < lastIdx; i++) {
            cb(this.partial);
            this.partial = data[i + 1];
        }
    }
}
exports.Chunker = Chunker;
Chunker.LINEFEED = '\n';
//# sourceMappingURL=chunker.js.map