/* Copyright © 2016 Ganchrow Scientific, SA all rights reserved */
'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const gsLogger_1 = require("../gsLogger");
let logger = gsLogger_1.getLogger('classifier');
exports.S_CLASSIFY = Symbol.for('classify');
const EMPTY_VALUE = '<MISSING>';
function classify(...keys) {
    return function (ctor) {
        Object.defineProperty(ctor.prototype, exports.S_CLASSIFY, {
            get: function () {
                return keys.map(function (key) {
                    if (this[key] === null || typeof this[key] === 'undefined') {
                        logger.error(new Error(`Cannot create classifier for key: ${key} in object: ${JSON.stringify(this)}`));
                        return EMPTY_VALUE;
                    }
                    let val = this[key];
                    return typeof val === 'function' ? val() : val.toString();
                }, this).join(':');
            }
        });
    };
}
exports.classify = classify;
//# sourceMappingURL=classify.js.map