/* Copyright © 2016 Ganchrow Scientific, SA all rights reserved */
'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
/*
 * Transforms string arguments to lowercase
 */
function lowercaseArguments(target, propertyName, descriptor) {
    if (descriptor && typeof descriptor.value === 'function') {
        let oldfunc = descriptor.value;
        descriptor.value = function () {
            return oldfunc.apply(this, Array.prototype.map.call(arguments, (val) => {
                return (typeof val === 'string' ? val.toLowerCase() : val);
            }));
        };
    }
    else {
        throw new Error('Not a valid descriptor for lowercaseArguments decorator');
    }
}
exports.lowercaseArguments = lowercaseArguments;
//# sourceMappingURL=lowercaseArguments.js.map