/* Copyright © 2015-2016 Ganchrow Scientific, SA all rights reserved */
'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
function precondition(message, condition) {
    return (target, key, method) => {
        return {
            value: function (...args) {
                if (!condition.apply(this, args)) {
                    throw new Error(`Function ${key} failed its precondition with args: [${args.toString()}].\nReason: ${message}`);
                }
                return method.value.apply(this, args);
            }
        };
    };
}
exports.precondition = precondition;
//# sourceMappingURL=precondition.js.map