/* Copyright © 2020 Ganchrow Scientific, SA all rights reserved */
'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
class IndexQueue {
    constructor() {
        this.data = Object.create(null);
        this.lastDequeueIndex = 0;
        this.nextEnqueueIndex = 0;
    }
    size() {
        return this.nextEnqueueIndex - this.lastDequeueIndex;
    }
    isEmpty() {
        return this.size() === 0;
    }
    enqueue(item) {
        this.data[this.nextEnqueueIndex++] = item;
    }
    dequeue() {
        if (this.lastDequeueIndex !== this.nextEnqueueIndex) {
            let dequeued = this.data[this.lastDequeueIndex];
            delete this.data[this.lastDequeueIndex++];
            return dequeued;
        }
    }
}
exports.IndexQueue = IndexQueue;
//# sourceMappingURL=indexQueue.js.map