"use strict";
/* Copyright © 2020 Ganchrow Scientific, SA all rights reserved */
Object.defineProperty(exports, "__esModule", { value: true });
const deepKeyValue_1 = require("./deepKeyValue");
const MATCH_DELIMITERS = { WORDS: /\{(.*?)\}/g, REPLACE: /\{|\}/g };
function interpolateValues(text, values, regexToMatchValues = MATCH_DELIMITERS.WORDS, regexToMatchDelimiters = MATCH_DELIMITERS.REPLACE) {
    let wordsToInterpolate = text.match(regexToMatchValues);
    if (wordsToInterpolate) {
        let replacers = wordsToInterpolate.map(r => new RegExp(r, 'g'));
        return replacers.reduce((txt, replacer) => {
            return txt.replace(replacer, (wordToInterpolate) => {
                let key = wordToInterpolate.replace(regexToMatchDelimiters, '');
                let value = deepKeyValue_1.deepKeyValue(values, key);
                if (value === undefined) {
                    throw 'The key was not found or is undefined';
                }
                return value;
            });
        }, text);
    }
    return text;
}
exports.interpolateValues = interpolateValues;
//# sourceMappingURL=interpolateValues.js.map