/* Copyright © 2019 Ganchrow Scientific, SA all rights reserved */
'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const utilities_1 = require("./utilities");
function joinFields(messages, batch = 10) {
    let sliced = [];
    for (let i = 0; i < Math.ceil(messages.length / batch); i++) {
        sliced.push(messages.slice(i * batch, i * batch + batch).reduce((cur, message) => {
            Object.entries(message).forEach(([k, v]) => {
                if (utilities_1.isUndefined(cur[k])) {
                    cur[k] = v;
                }
                else {
                    cur[k] = `${cur[k]},${v}`;
                }
            });
            return cur;
        }, {}));
    }
    return sliced;
}
exports.joinFields = joinFields;
//# sourceMappingURL=joinFields.js.map