export declare type Handler = (type: string, task: any) => void;
export declare type ErrorHandler = (error: Error, type: string, task: any, pushBack: () => void) => void;
export declare type TasksDump = {
    [index: number]: {
        type: string;
        task: any;
        seq: number;
    };
};
export declare class TaskQueue<T> {
    private nextQueue;
    private pendantQueue;
    private processingTypes;
    private moreRecentTypes;
    private handler;
    private handleError;
    private discardTask;
    private maxConcurrency;
    private realMaxConcurrency;
    private pausePromiseResolver;
    private isPaused;
    private working;
    private isDumping;
    private executingPromises;
    private sequence;
    private shouldPause;
    private eventEmitter;
    private queueDelay;
    constructor(concurrency: number, handler: Handler, handleError?: ErrorHandler, discardTask?: Handler, restoredTasks?: TasksDump, queueDelay?: number);
    push(type: string, task: T): Promise<void>;
    pause(): void;
    resume(): void;
    dump(): Promise<void>;
    onDump(listener: any): void;
    private isProccesingType;
    private restore;
    private pushBackFactory;
    private handle;
    private execute;
}
